#ifndef ESTUDIANT_HH
#define ESTUDIANT_HH

class Estudiant {

  // Tipus de mdul: dades
  // Descripci del tipus: cont el DNI d'un estudiant, 
  // que s un enter positiu, i pot tenir nota, que seria un double 
  // Les notes vlides sn les de l'interval 0..nota_maxima() 

private:    
  int dni;
  double nota;
  bool amb_nota;
  static const int MAX_NOTA = 10;
  /* 
     Invariant de la representaci: 
     - 0 <= dni
     - si amb_nota, llavors 0 <= nota <= MAX_NOTA 
  */

public:
  //Constructores

  Estudiant();
  /* Pre: cert */ 
  /* Post: el resultat s un estudiant amb DNI = 0 i sense nota */

  Estudiant(int dni);
  /* Pre: dni >= 0 */ 
  /* Post: el resultat s un estudiant amb DNI=dni i sense nota */

  // Destructora: esborra automticament els objectes locals en sortir 
  // d'un mbit de visibilitat

  ~Estudiant();

  //Modificadores

  void afegir_nota(double nota);
  /* Pre: el parmetre implcit no t nota, 0 <= "nota" <= nota_maxima() */
  /* Post: la nota del parmetre implcit passa a ser "nota" */
   
  void modificar_nota(double nota);
  /* Pre: el parmetre implcit t nota, 0 <= "nota" <= nota_maxima() */
  /* Post: la nota del parmetre implcit passa a ser "nota" */
                                    
  //Consultores

  int consultar_DNI() const;
  /* Pre: cert  */
  /* Post: el resultat s el DNI del parmetre implcit */

  double consultar_nota() const;
  /* Pre: el parmetre implcit t nota */
  /* Post: el resultat s la nota del parmetre implcit */

  static double nota_maxima();
  /* Pre: cert */
  /* Post: el resultat s la nota mxima dels elements de la classe */

  bool te_nota()  const;
  /* Pre: cert  */
  /* Post: el resultat indica si el parmetre implcit t nota o no */

  static bool comp(const Estudiant& e1, const Estudiant& e2); 
  /* Pre: cert  */
  /* Post: el resultat indica si el DNI d'e1 es ms petit que el d'e2 */

  // Lectura i escriptura

  void llegir();
  /* Pre:  hi ha preparats al canal estandar d'entrada un enter no negatiu i un double */
  /* Post: el parmetre implcit passa a tenir els atributs llegits 
     del canal estndard d'entrada; si el double no pertany a l'interval 
     [0..nota_maxima()], el p.i. es queda sense nota */

  void escriure() const;
  /* Pre: cert */
  /* Post: s'han escrit els atributs del parmetre implcit 
     al canal estndard de sortida; si no t nota escriu "NP" */
};

#endif

